// ScreenWindowCtl.cpp : Implementation of the CScreenWindowCtrl ActiveX Control class.

#include "stdafx.h"
#include "ScreenWindow.h"
#include "ScreenWindowCtl.h"
#include "ScreenWindowPpg.h"
#include "ScreenWindowDisplayAbout.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CScreenWindowCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CScreenWindowCtrl, COleControl)
//{{AFX_MSG_MAP(CScreenWindowCtrl)
	ON_WM_CHAR()
	ON_WM_SETFOCUS()
	ON_WM_KILLFOCUS()
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
ON_OLEVERB(AFX_IDS_VERB_EDIT, OnEdit)
ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CScreenWindowCtrl, COleControl)
//{{AFX_DISPATCH_MAP(CScreenWindowCtrl)
	DISP_PROPERTY_NOTIFY(CScreenWindowCtrl, "Rows", m_rows, OnRowsChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CScreenWindowCtrl, "Columns", m_columns, OnColumnsChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CScreenWindowCtrl, "AboutText", m_aboutText, OnAboutTextChanged, VT_BSTR)
	DISP_PROPERTY_NOTIFY(CScreenWindowCtrl, "InputLength", m_inputLength, OnInputLengthChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CScreenWindowCtrl, "TabSpace", m_tabSpace, OnTabSpaceChanged, VT_I2)
	DISP_PROPERTY_NOTIFY(CScreenWindowCtrl, "curRow", curRow, OnCurRowChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CScreenWindowCtrl, "curColumn", curColumn, OnCurColumnChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CScreenWindowCtrl, "TextColor", m_textColor, OnTextColorChanged, VT_COLOR)
	DISP_PROPERTY_NOTIFY(CScreenWindowCtrl, "TextBackgroundColor", m_textBackgroundColor, OnTextBackgroundColorChanged, VT_COLOR)
	DISP_PROPERTY_NOTIFY(CScreenWindowCtrl, "FontWidth", SCR_X, OnFontWidthChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CScreenWindowCtrl, "FontHeight", SCR_Y, OnFontHeightChanged, VT_I4)
	DISP_FUNCTION(CScreenWindowCtrl, "KbHit", KbHit, VT_BOOL, VTS_NONE)
	DISP_FUNCTION(CScreenWindowCtrl, "DisplayAbout", DisplayAbout, VT_BOOL, VTS_NONE)
	DISP_FUNCTION(CScreenWindowCtrl, "ClearInput", ClearInput, VT_BOOL, VTS_NONE)
	DISP_FUNCTION(CScreenWindowCtrl, "ClearLine", ClearLine, VT_BOOL, VTS_NONE)
	DISP_FUNCTION(CScreenWindowCtrl, "ClearScr", ClearScr, VT_BOOL, VTS_NONE)
	DISP_FUNCTION(CScreenWindowCtrl, "Write", Write, VT_BOOL, VTS_BSTR)
	DISP_FUNCTION(CScreenWindowCtrl, "WriteLine", WriteLine, VT_BOOL, VTS_BSTR)
	DISP_FUNCTION(CScreenWindowCtrl, "ReadLineAsync", ReadLineAsync, VT_BOOL, VTS_NONE)
	DISP_FUNCTION(CScreenWindowCtrl, "ReadByte", ReadByte, VT_I2, VTS_BOOL)
	DISP_FUNCTION(CScreenWindowCtrl, "ReadLine", ReadLine, VT_BSTR, VTS_NONE)
	//}}AFX_DISPATCH_MAP
DISP_FUNCTION_ID(CScreenWindowCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CScreenWindowCtrl, COleControl)
//{{AFX_EVENT_MAP(CScreenWindowCtrl)
	EVENT_CUSTOM("OnReadLineDone", FireReadLineDone, VTS_BSTR)
	EVENT_CUSTOM("OnLoadFinished", FireLoadFinished, VTS_NONE)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CScreenWindowCtrl, 1)
PROPPAGEID(CScreenWindowPropPage::guid)
END_PROPPAGEIDS(CScreenWindowCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CScreenWindowCtrl, "SCREENWINDOW.ScreenWindowCtrl.1", 0x1a69b97e, 0xb062, 0x11d1, 0xb2, 0x1a, 0, 0x60, 0x8, 0x27, 0x9a, 0x49)
					   
					   
/////////////////////////////////////////////////////////////////////////////
// Type library ID and version
					   
IMPLEMENT_OLETYPELIB(CScreenWindowCtrl, _tlid, _wVerMajor, _wVerMinor)
					   
					   
/////////////////////////////////////////////////////////////////////////////
// Interface IDs
					   
const IID BASED_CODE IID_DScreenWindow = { 0x1a69b97c, 0xb062, 0x11d1, { 0xb2, 0x1a, 0, 0x60, 0x8, 0x27, 0x9a, 0x49 } };
const IID BASED_CODE IID_DScreenWindowEvents = { 0x1a69b97d, 0xb062, 0x11d1, { 0xb2, 0x1a, 0, 0x60, 0x8, 0x27, 0x9a, 0x49 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwScreenWindowOleMisc =
OLEMISC_ACTIVATEWHENVISIBLE |
OLEMISC_SETCLIENTSITEFIRST |
OLEMISC_INSIDEOUT |
OLEMISC_CANTLINKINSIDE |
OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CScreenWindowCtrl, IDS_SCREENWINDOW, _dwScreenWindowOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CScreenWindowCtrl::CScreenWindowCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CScreenWindowCtrl

BOOL CScreenWindowCtrl::CScreenWindowCtrlFactory::UpdateRegistry(BOOL bRegister)
{
  // TODO: Verify that your control follows apartment-model threading rules.
  // Refer to MFC TechNote 64 for more information.
  // If your control does not conform to the apartment-model rules, then
  // you must modify the code below, changing the 6th parameter from
  // afxRegInsertable | afxRegApartmentThreading to afxRegInsertable.
  
  if (bRegister)
	return AfxOleRegisterControlClass(
	AfxGetInstanceHandle(),
	m_clsid,
	m_lpszProgID,
	IDS_SCREENWINDOW,
	IDB_SCREENWINDOW,
	afxRegInsertable | afxRegApartmentThreading,
	_dwScreenWindowOleMisc,
	_tlid,
	_wVerMajor,
	_wVerMinor);
  else
	return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CScreenWindowCtrl::CScreenWindowCtrl - Constructor

CScreenWindowCtrl::CScreenWindowCtrl()
{
  InitializeIIDs(&IID_DScreenWindow, &IID_DScreenWindowEvents);
//  CFontHolder cFont = this->InternalGetFont();
  
  // Set hFont to the selected font
//  (cFont.m_pFont)->get_hFont(&hFont);
  
  // Create the palette and store it in pPalette
/*  makePalette(&pPalette);
  
  // Set the echo flag to false
  echoChars = false;
  
  // Set the tab space to 5 if the property doesn't exist
  if (!m_tabSpace)
	m_tabSpace = 5;
  
  // Set the input row/columns to zero
  inRow = 0;
  inColumn = 0;
  asyncRead = false;
  curRow = 0;
  curColumn = 0;*/

  // Create the desired font from the properties
/*  CFontHolder fontHolder = InternalGetFont();
  IFont *iFont = fontHolder.m_pFont;
  if (iFont) {
    HFONT hFont;
    iFont->get_hFont(&hFont);
    pFont = CFont::FromHandle(hFont);
  } else
	pFont = NULL;*/
  /*pFont = new CFont();
  pFont->CreateFont(12, 0, 0, 0, 0, 0, 0, 0, 255, 0, 0, 0, 0, "Terminal");

  // Set the default colors to the properties
  curColor.bgColor = palRGB(m_textBackgroundColor);
  curColor.fgColor = palRGB(m_textColor);

  // Create an allocation for the screen
  scr = NULL;
  ChangeAllocation(m_rows, m_columns);

  // Assign the default input buffer length and allocate that space
  m_inputLength = m_rows * m_columns + 1;
  hscrIn = GlobalAlloc(GHND, sizeof(BYTE) * m_inputLength);
  scrIn = (LPSTR) GlobalLock(hscrIn);
  scrIn[0] = '\0';
  
  caretHide = false;
  SetCaretState(false, true);*/

  // Set mutual exclusion objects
  screenMutex = new CMutex(false, NULL, NULL);
  inputMutex = new CMutex(false, NULL, NULL);

  // Create a caret
  caretHide = false;
  pFont = NULL;
  hscrIn = NULL;
  scr = NULL;
  color = NULL;

  // Set the prevRows and prevColumns objects
  prevRows = -1;
  prevColumns = -1;

  // Set initial timer IDs
  STARTUPID = 500;
  CARETID = 501;

  // Set the default text extents
  SCR_X = 8;
  SCR_Y = 12;

  // Set the echo flag to false
  echoChars = false;
  
  // Set the tab space to 5
  m_tabSpace = 5;

  // Set the input row/columns to zero
  inRow = 0;
  inColumn = 0;
  asyncRead = false;
  curRow = 0;
  curColumn = 0;

  // Set the windowOn to false
  windowOn = false;

  // Set the default About Text
  m_aboutText = DEFAULT_ABOUTTEXT;

  // Set values for the colors
  m_textBackgroundColor = RGB(0, 0, 0);
  m_textColor = RGB(192, 192, 192);

  // Set the default colors to the properties
//  curColor.bgColor = palRGB(m_textBackgroundColor);
//  curColor.fgColor = palRGB(m_textColor);

  // Create an allocation for the screen
//  scr = NULL;
//  ChangeAllocation(m_rows, m_columns);

  // Assign the default input buffer length and allocate that space
//  m_inputLength = m_rows * m_columns + 1;
//  hscrIn = GlobalAlloc(GHND, sizeof(BYTE) * m_inputLength);
//  scrIn = (LPSTR) GlobalLock(hscrIn);
//  scrIn[0] = '\0';
}


/////////////////////////////////////////////////////////////////////////////
// CScreenWindowCtrl::~CScreenWindowCtrl - Destructor

CScreenWindowCtrl::~CScreenWindowCtrl()
{
  delete screenMutex;
  delete inputMutex;
}


/////////////////////////////////////////////////////////////////////////////
// CScreenWindowCtrl::OnDraw - Drawing function

void CScreenWindowCtrl::OnDraw(CDC* pDC, const CRect& rcBounds, const CRect& rcInvalid)
{
  // If we're initialized, then paint (but only if the org is for our control)
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
//  if (windowOn && pFont && (rcBounds.left == 0) && (rcBounds.top == 0)) {
  if (windowOn && pFont) {
/*	// Check the text extents
	CSize *lpSizeL;
	BOOL resized = false:
	pDC->GetWindowExt(lpSizeL);
    pDC->LPtoDP(lpSizeL);
    if (lpSizeL->cx > (LONG) (SCR_X * m_columns + 1)) {
	  lpSizeL->cx = (LONG) (SCR_X * m_columns + 1);
	  resized = true;
	}
    if (lpSizeL->cy > (LONG) (SCR_Y * m_rows + 1)) {
	  lpSizeL->cy = (LONG) (SCR_Y * m_rows + 1);
	  resized = true;
	}
    if (resized) {
	  pDC->DPtoLP(lpSizeL);*/

    // Repaint a portion (or all) of the screen
	CFont *pOldFont = (CFont *) pDC->SelectObject(pFont);
	COLORREF bgColor = curColor.bgColor, fgColor = curColor.fgColor;
	RECT rect = rcInvalid;
	RECT bounds = rcBounds;
	char strOutput[2];
	long r, c;
	
	// Redraw the part of the control that needs updating
	rect.top = (rect.top + bounds.top) / SCR_Y;
	rect.bottom = rect.bottom / SCR_Y + 1;
	rect.left = (rect.left + bounds.left) / SCR_X;
	rect.right = rect.right / SCR_X + 1;
	if (rect.bottom >= m_rows)
	  rect.bottom = m_rows - 1;
	if (rect.right >= m_columns)
	  rect.right = m_columns - 1;
	if (rect.top < 0)
	  rect.top = 0;
	if (rect.left < 0)
	  rect.left = 0;
	
	// Set the default text and background colors
	pDC->SetTextColor(curColor.fgColor);
	pDC->SetBkColor(curColor.bgColor);

	// Initialize the strOutput variable
	strOutput[1] = '\0';
	
	// Disable the caret
	SetCaretState(false, false);
	
	// Repaint every character individually
	for (r = rect.top; r <= rect.bottom; r++)
	{
	  for (c = rect.left; c <= rect.right; c++)
	  {
		// Set the character's colors, if setting is required
		if (fgColor != color[r][c]->fgColor)
		{
		  fgColor = color[r][c]->fgColor;
		  pDC->SetTextColor(fgColor);
		}
		if (bgColor != color[r][c]->bgColor)
		{
		  bgColor = color[r][c]->bgColor;
		  pDC->SetBkColor(bgColor);
		}
		
		// Write the character to the screen
		strOutput[0] = scr[r][c];
		pDC->TextOut(c * SCR_X + bounds.left, r * SCR_Y + bounds.top, strOutput, 1);
	  }
	}
	
	// Restore the DC
	pDC->SelectObject(pOldFont);
	
	// Enable the caret
	SetCaretState(true, true);
  } else {
	// Draw a rectangle in the current background color
//	CBrush bkBrush(m_textBackgroundColor);
//	pDC->FillRect(rcBounds, &bkBrush);
  }
  screenMutex->Unlock();
  //delete screenLock;
}


/////////////////////////////////////////////////////////////////////////////
// CScreenWindowCtrl::DoPropExchange - Persistence support

void CScreenWindowCtrl::DoPropExchange(CPropExchange* pPX)
{
  ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
  COleControl::DoPropExchange(pPX);
  
  if (pPX->GetVersion() == (DWORD)MAKELONG(_wVerMinor, _wVerMajor))
  {
/*	PX_Bool(pPX, _T("CircleShape"), m_circleShape, true);
	PX_Short(pPX, _T("CircleOffset"), m_circleOffset, 0);
	PX_Long(pPX, _T("FlashColor"), (long &)m_flashColor, RGB(0xFF, 0x00, 0x00));*/

  //CSingleLock *screenLock = new CSingleLock(screenMutex, false);
	screenMutex->Lock(INFINITE);
    //CSingleLock *inputLock = new CSingleLock(inputMutex, false);
	inputMutex->Lock(INFINITE);
	PX_String(pPX, _T("AboutText"), m_aboutText, _T("ActiveX Program"));
	PX_Long(pPX, _T("Columns"), (long &)m_columns, 80);
	PX_Long(pPX, _T("curColumn"), (long &)curColumn, 0);
	PX_Long(pPX, _T("curRow"), (long &)curRow, 0);
	PX_Long(pPX, _T("InputLength"), (long &)m_inputLength, 80 * 25);
	PX_Long(pPX, _T("Rows"), (long &)m_rows, 25);
	PX_Long(pPX, _T("TabSpace"), (long &)m_tabSpace, 5);
	PX_Long(pPX, _T("TextBackgroundColor"), (long &)m_textBackgroundColor, RGB(0,0,0));
	PX_Long(pPX, _T("TextColor"), (long &)m_textColor, RGB(192,192,192));
    screenMutex->Unlock();
    //delete screenLock;
    inputMutex->Unlock();
    //delete inputLock;
  }
/*  else if (pPX->IsLoading())
  {
	// Skip over persistent data
	BOOL bDummy;
	short sDummy;
	long lDummy;
	CString strDummy;
	PX_Bool(pPX, _T("CircleShape"), bDummy, false);
	PX_Short(pPX, _T("CircleOffset"), sDummy, 0);
	PX_Long(pPX, _T("FlashColor"), lDummy, 0);
	PX_String(pPX, _T("Note"), strDummy, _T(""));
	
	// Force property values to these defaults
	m_circleShape = true;
	m_circleOffset = 0;
	m_flashColor = RGB(0xFF, 0x00, 0x00);
	m_note = _T("");
  }*/
}


/////////////////////////////////////////////////////////////////////////////
// CScreenWindowCtrl::GetControlFlags -
// Flags to customize MFC's implementation of ActiveX controls.
//
// For information on using these flags, please see MFC technical note
// #nnn, "Optimizing an ActiveX Control".
DWORD CScreenWindowCtrl::GetControlFlags()
{
  DWORD dwFlags = COleControl::GetControlFlags();
  
  // The control's output is not being clipped.
  // The control guarantees that it will not paint outside its
  // client rectangle.
//  dwFlags &= ~clipPaintDC;
  
  // The control will not be redrawn when making the transition
  // between the active and inactivate state.
//  dwFlags |= noFlickerActivate;
  return dwFlags;
}


/////////////////////////////////////////////////////////////////////////////
// CScreenWindowCtrl::OnResetState - Reset control to default state

void CScreenWindowCtrl::OnResetState()
{
  COleControl::OnResetState();  // Resets defaults found in DoPropExchange
  // Create a new font
//  if (pFont)
//	delete pFont;
//  pFont = new CFont();
//  pFont->CreateFont(12, 0, 0, 0, 0, 0, 0, 0, 255, 0, 0, 0, 0, "Terminal");

  // Set the default text extents
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  //CSingleLock *inputLock = new CSingleLock(inputMutex, false);
  inputMutex->Lock(INFINITE);
  SCR_X = 8;
  SCR_Y = 12;

  // Clear the caret, if any
//  SetCaretState(false, false);

  // Free the input buffer
/*  if (hscrIn) {
    GlobalUnlock(hscrIn);
    GlobalFree(hscrIn);
  }

  // Free the screen buffers
  if (scr)
    FreeAllocation();*/

  // Create the palette and store it in pPalette
//  makePalette(&pPalette);
  
  // Set the echo flag to false
  echoChars = false;
  
  // Set the tab space to 5
  m_tabSpace = 5;

  // Make the default font Terminal
/*  CFontHolder fontHolder = InternalGetFont();
  IFont *iFont = fontHolder.m_pFont;
  CString *fontName = new CString("Terminal");
  BSTR bStr = fontName->AllocSysString();
  iFont->put_Name(bStr);
  SysFreeString(bStr);
  CY cy;
  cy.Lo = 12;
  cy.Hi = 0;
  iFont->put_Size(cy);
  iFont->put_Bold(0);
  iFont->put_Italic(0);
  iFont->put_Underline(0);
  iFont->put_Weight(0);
  iFont->put_Strikethrough(0);
  iFont->put_Charset(255);*/

/*  pFont = CFont::FromHandle(iFont->get_hFont());
  pFont = fontHolder->m_pFont;
  pFont->CreateFont(12, 0, 0, 0, 0, 0, 0, 0, 255, 0, 0, 0, 0, "Terminal");*/
/*
  
  FONTDESC *fd;
  CString *fontName = new CString("Terminal");
  fontName->SetSysString(fd->lpstrName);
  delete fontName;
  fd->cySize = 12;
  fd->sWeight = 0;
  fd->sCharset = 255;
  fd->fItalic = 0;
  fd->fUnderline = 0;
  fd->fStrikethrough = 0;
  SetFont(fd);
  if (pFont)
    delete pFont;
  pFont = new CFont();
  pFont->CreateFont(12, 0, 0, 0, 0, 0, 0, 0, 255, 0, 0, 0, 0, "Terminal");*/
  
  // Set the input row/columns to zero
  inRow = 0;
  inColumn = 0;
  asyncRead = false;
  curRow = 0;
  curColumn = 0;

  // Set the default About Text
  m_aboutText = DEFAULT_ABOUTTEXT;

  // Set values for the colors
  m_textBackgroundColor = RGB(0, 0, 0);
  m_textColor = RGB(192, 192, 192);

  // Set the default colors to the properties
/*  curColor.bgColor = palRGB(m_textBackgroundColor);
  curColor.fgColor = palRGB(m_textColor);

  // Create an allocation for the screen
  scr = NULL;
  ChangeAllocation(m_rows, m_columns);

  // Assign the default input buffer length and allocate that space
  m_inputLength = m_rows * m_columns + 1;
  hscrIn = GlobalAlloc(GHND, sizeof(BYTE) * m_inputLength);
  scrIn = (LPSTR) GlobalLock(hscrIn);
  scrIn[0] = '\0';*/
  
  // Create a caret
//  caretHide = false;
//  SetCaretState(false, true);
  screenMutex->Unlock();
  //delete screenLock;
  inputMutex->Unlock();
  //delete inputLock;
}


/////////////////////////////////////////////////////////////////////////////
// CScreenWindowCtrl::AboutBox - Display an "About" box to the user

void CScreenWindowCtrl::AboutBox()
{
  CDialog dlgAbout(IDD_ABOUTBOX_SCREENWINDOW);
  dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CScreenWindowCtrl message handlers

void CScreenWindowCtrl::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
  // A character was typed in; place it into the input buffer
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  //CSingleLock *inputLock = new CSingleLock(inputMutex, false);
  inputMutex->Lock(INFINITE);
  long len = lstrlen(scrIn);
  if ((len == m_inputLength) && (nChar != '\b') && !((nChar == '\r') && echoChars))
  {
	// No more characters are available; play a MB_ICONEXCLAMATION sound
	MessageBeep(MB_ICONEXCLAMATION);
  }
  else
  {
	// If the inRow and inColumn variables are not set, then set them now
	if ((inRow == 0) && (inColumn == 0) && !echoChars && !inPosSet) {
	  inRow = curRow;
	  inColumn = curColumn;
	  inPosSet = true;
	}

	// Asynchronous read processing
    if (asyncRead) {
	  // Return this string if we are at an [Enter]
	  if (nChar == '\r') {
		// Create buffer
		LPSTR lineText;
		HGLOBAL hGlobal;
		hGlobal = GlobalAlloc(GHND, (len + 2) * sizeof(char));
		lineText = (LPSTR) GlobalLock(hGlobal);
		lstrcpyn(lineText, scrIn, len + 1);

		// Change variables
		internalWrite("\n");
		inPosSet = false;
	    asyncRead = false;
		echoChars = false;
	    scrIn[0] = '\0';
	    inRow = 0;
	    inColumn = 0;

		// Fire event
	    FireReadLineDone(lineText);

		// Free memory and return
		GlobalUnlock(hGlobal);
		GlobalFree(hGlobal);
	    return;
	  }
	  
	  // If this is a backspace, then decrease the string
	  if (nChar == '\b') {
		if (len > 0) {
		  internalWrite("\b");
		  scrIn[len - 1] = '\0';
		}
		return;
	  }
	}

	// If this is a tab, then represent it as m_tabLength in the input string
	// if we are echoing
	if (echoChars && (nChar == '\t')) {
	  // Check the space available
	  if (len + m_tabSpace > m_inputLength) {
	    // No more characters are available; play a MB_ICONEXCLAMATION sound
	    MessageBeep(MB_ICONEXCLAMATION);
		return;
	  } else {
		// Add spaces to the input buffer and write it
		long i;
	    LPSTR scrOut = (LPSTR) GlobalAlloc(GPTR, m_tabSpace + 1);
		for (i = 0; i < m_tabSpace; i++) {
		  scrIn[len + i] = ' ';
		  scrOut[i] = ' ';
		}
		scrIn[len + i] = '\0';
		scrOut[i] = '\0';
		internalWrite(scrOut);
		GlobalFree(GlobalHandle(scrOut));
		return;
	  }
	}

	// If we are to echo the characters, display this on the screen
	// and on the screen buffer
	if (echoChars && (nChar != '\r'))
	{
	  char scrOut[2];
	  scrOut[0] = (char) nChar;
	  scrOut[1] = '\0';
	  internalWrite(scrOut);
	}

	// There is room; add this character to the input buffer
	scrIn[len] = (char) nChar;
	scrIn[len + 1] = '\0';
  }
  inputMutex->Unlock();
  //delete inputLock;
  screenMutex->Unlock();
  //delete screenLock;

//  COleControl::OnChar(nChar, nRepCnt, nFlags);
}

void CScreenWindowCtrl::OnSetFocus(CWnd* pOldWnd) 
{
  COleControl::OnSetFocus(pOldWnd);
  
  // Set the caret status
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  caretHide = false;
  if (!caretStatus)
	SetCaretState(!caretStatus, true);
  screenMutex->Unlock();
  //delete screenLock;
}

void CScreenWindowCtrl::OnKillFocus(CWnd* pNewWnd) 
{
  COleControl::OnKillFocus(pNewWnd);
  
  // We're losing the focus :-( !!  Destroy the caret (sorry, Buggs Bunny!)
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  SetCaretState(false, false);
  caretHide = true;
  screenMutex->Unlock();
  //delete screenLock;
}

void CScreenWindowCtrl::OnRowsChanged() 
{
  // Update the allocation (this wipes out the display)
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  ChangeAllocation(m_rows, m_columns);

  // Set the column and row to zero
  curRow = 0;
  curColumn = 0;

  // Repaint the control
  SetControlSize(m_columns * SCR_X, m_rows * SCR_Y);
  screenMutex->Unlock();
  //delete screenLock;
  InvalidateControl(NULL);

  SetModifiedFlag();
}

void CScreenWindowCtrl::OnColumnsChanged() 
{
  // Update the allocation (this wipes out the display)
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  ChangeAllocation(m_rows, m_columns);

  // Set the column and row to zero
  curRow = 0;
  curColumn = 0;

  // Repaint the control
  SetControlSize(m_columns * SCR_X, m_rows * SCR_Y);
  screenMutex->Unlock();
  //delete screenLock;
  InvalidateControl(NULL);

  SetModifiedFlag();
}

BOOL CScreenWindowCtrl::KbHit() 
{
  // Has a key been pressed (or hit)?  Return the number of bytes if there are some
  //CSingleLock *inputLock = new CSingleLock(inputMutex, false);
  inputMutex->Lock(INFINITE);
  bool kbHit = scrIn[0] != '\0';
  inputMutex->Unlock();
  //delete inputLock;
  return kbHit;
}

BOOL CScreenWindowCtrl::DisplayAbout() 
{
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  CScreenWindowDisplayAbout *dlgAbout = new CScreenWindowDisplayAbout(this, m_aboutText);
  screenMutex->Unlock();
  //delete screenLock;
  dlgAbout->DoModal();
  delete dlgAbout;

  return true;
}

void CScreenWindowCtrl::OnAboutTextChanged() 
{
  SetModifiedFlag();
}

/*BOOL CScreenWindowCtrl::GetFontMultipliers(short FAR* xMultiplier, short FAR* yMultiplier) 
{
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  *xMultiplier = (short) SCR_X;
  *yMultiplier = (short) SCR_Y;
  screenMutex->Unlock();
  //delete screenLock;
  return true;
}*/

void CScreenWindowCtrl::OnInputLengthChanged() 
{
  // Set the new input buffer length by freeing the old and creating the new
  //CSingleLock *inputLock = new CSingleLock(inputMutex, false);
  inputMutex->Lock(INFINITE);
  HGLOBAL newBuffer;
  GlobalUnlock(hscrIn);
  
  // If the allocation routine did not work, return false
  if ((newBuffer = GlobalReAlloc(hscrIn, sizeof(BYTE) * (m_inputLength + 2), NULL)) == NULL)
	return;
  
  // Set the new handle and lock it
  hscrIn = newBuffer;
  scrIn = (LPSTR) GlobalLock(hscrIn);
  //m_inputLength = (UINT) m_inputLength + 1;
  
  // Reset the new buffer
  scrIn[0] = '\0';
  inputMutex->Unlock();
  //delete inputLock;
  
  SetModifiedFlag();
}

BOOL CScreenWindowCtrl::ClearLine() 
{
  // Clear the text on the current row from the current column to the last column
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  CDC *pDC = GetDC(NULL, OLEDC_PAINTBKGND);
  CFont *pOldFont = (CFont *) pDC->SelectObject(pFont);
//  CPalette *pOldPal = pDC->SelectPalette(&pPalette, false);
  long i;
  
  // Set the background color and write the spaces while reflecting in memory
  pDC->SetBkColor(curColor.bgColor);
  for (i = curColumn; i <= m_columns - 1; i++)
  {
	scr[curRow][i] = ' ';
	color[curRow][i]->bgColor = curColor.bgColor;
	color[curRow][i]->fgColor = curColor.fgColor;
	pDC->TextOut(i * SCR_X, curRow * SCR_Y, " ", 1);
  }
  
  // Clean up the device context and return NULL
//  pDC->SelectPalette(pOldPal, false);
  pDC->SelectObject(pOldFont);
  ReleaseDC(pDC);
  screenMutex->Unlock();
  //delete screenLock;
  return true;
}

void CScreenWindowCtrl::OnTabSpaceChanged() 
{
  SetModifiedFlag();
}

BOOL CScreenWindowCtrl::ClearScr() 
{
  // Clear the entire screen!!
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  CDC *pDC = GetDC(NULL, OLEDC_PAINTBKGND);
  CFont *pOldFont = (CFont *) pDC->SelectObject(pFont);
//  CPalette *pOldPal = pDC->SelectPalette(&pPalette, false);
  CBrush *pBrush = new CBrush();
  pBrush->CreateSolidBrush(curColor.bgColor);
  CBrush *pOldBrush = (CBrush *) pDC->SelectObject(pBrush);
  RECT rect;
  long r, c;
  
  // Hide the caret
  SetCaretState(false, false);
  
  // Clear the memory
  for (r = 0; r < m_rows; r++)
  {
	for (c = 0; c < m_columns; c++)
	{
	  scr[r][c] = ' ';
	  color[r][c]->fgColor = curColor.fgColor;
	  color[r][c]->bgColor = curColor.bgColor;
	}
  }
  curRow = 0;
  curColumn = 0;
  
  // Set the background color and write a large rectangle
  pDC->SetBkColor(curColor.bgColor);
  rect.top = 0;
  rect.left = 0;
  rect.right = m_columns * SCR_X + 1;
  rect.bottom = m_rows * SCR_Y + 1;
  pDC->FillRect(&rect, pBrush);
  
  // Clean up the device context and return NULL
  pDC->SelectObject(pOldBrush);
//  pDC->SelectPalette(pOldPal, false);
  pDC->SelectObject(pOldFont);
  ReleaseDC(pDC);
  delete pBrush;
  
  // Show the caret
  SetCaretState(true, true);
  screenMutex->Unlock();
  //delete screenLock;
  return true;
}

BOOL CScreenWindowCtrl::SetPos(long row, long column) 
{
  // Hide the caret
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  SetCaretState(false, false);

  // Change our internal row/column variables
  curRow = row;
  curColumn = column;

  // Set the caret position to the current row/column
  SetCaretState(true, true);
  screenMutex->Unlock();
  //delete screenLock;
  return true;
}

/*BOOL CScreenWindowCtrl::GetPos(long FAR* row, long FAR* column) 
{
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  *row = curRow;
  *column = curColumn;
  screenMutex->Unlock();
  //delete screenLock;
  return true;
}*/

void CScreenWindowCtrl::OnCurRowChanged() 
{
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  SetPos(curRow, curColumn);
  screenMutex->Unlock();
  //delete screenLock;
  SetModifiedFlag();
}

void CScreenWindowCtrl::OnCurColumnChanged() 
{
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  SetPos(curRow, curColumn);
  screenMutex->Unlock();
  //delete screenLock;
  SetModifiedFlag();
}

void CScreenWindowCtrl::OnTextColorChanged() 
{
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  curColor.fgColor = TranslateColor(m_textColor);
  screenMutex->Unlock();
  //delete screenLock;
  SetModifiedFlag();
}

void CScreenWindowCtrl::OnTextBackgroundColorChanged() 
{
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  curColor.bgColor = TranslateColor(m_textBackgroundColor);
  screenMutex->Unlock();
  //delete screenLock;
  SetModifiedFlag();
}


BOOL CScreenWindowCtrl::Write(LPCTSTR str) 
{
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  bool retVal = internalWrite(str);
  screenMutex->Unlock();
  //delete screenLock;
  return retVal;
}

bool CScreenWindowCtrl::internalWrite(LPCTSTR str)
{
  // Get the DC and initialize the DC characteristics with the font and palette
  CDC *pDC = GetDC(NULL, OLEDC_PAINTBKGND);
  CFont *pOldFont = (CFont *) pDC->SelectObject(pFont);
//  CPalette *pOldPal = pDC->SelectPalette(&pPalette, false);
  int i, end;
  
  // Hide the caret
  SetCaretState(false, false);
  
  // Set the text and background colors
  pDC->SetTextColor(curColor.fgColor);
  pDC->SetBkColor(curColor.bgColor);
  
  // Process every byte until the terminating NULL is read, or the EOLN
  i = 0;
  end = lstrlen(str) - 1;
  while (i <= end)
  {
	switch (str[i])
	{
	  case '\n' :
	  {
		// Line Feed
		curColumn = 0;
		curRow++;
		if (curRow > m_rows - 1)
		{
		  // Scroll the current window up by one
		  LPSTR firstRow = scr[0];
		  LPCOLORINFO *colorRow = color[0];
		  RECT rect, newRect;
		  int r;
		  
		  // Initialize rectangle variables
		  rect.top = 0;
		  rect.bottom = m_rows * SCR_Y;
		  rect.left = 0;
		  rect.right = m_columns * SCR_X;
		  
		  // Scroll the DC
		  pDC->ScrollDC(0, -1 * SCR_Y, &rect, NULL, NULL, &newRect);
		  
		  // Reflect this change in memory by moving every row up by one
		  for (r = 0; r <= m_rows - 2; r++)
		  {
			scr[r] = scr[r + 1];
			color[r] = color[r + 1];
		  }
		  scr[m_rows - 1] = firstRow;
		  color[m_rows - 1] = colorRow;
		  
		  // Clear the bottom row on the screen
		  memset(scr[m_rows - 1], ' ', m_columns);
		  pDC->TextOut(0, (m_rows - 1) * SCR_Y, scr[m_rows - 1], m_columns);
		  
		  // Clear the bottom row in memory (with NULLs this time)
		  memset(scr[m_rows - 1], '\0', m_columns);
		  
		  // Set every color in the bottom row to the current colors
		  for (r = 0; r <= m_columns - 1; r++)
		  {
			color[m_rows - 1][r]->bgColor = curColor.bgColor;
			color[m_rows - 1][r]->fgColor = curColor.fgColor;
		  }
		  
		  // Set the current row to the last one
		  curRow--;
		}
		break;
	  }
	  
	  case '\r' :
	  {
		// Enter Key (carriage return, NOT line feed)
		curColumn = 0;
		break;
	  }
	  
	  case '\b' :
	  {
		// Backspace
		
		// If we are at the input starting place, then go up
		if (!((curRow == inRow) && (curColumn == inColumn)))
		{
		  if ((int) curColumn - 1 >= 0)
		  {
			// Erase the character before us and reflect that in the buffer
			pDC->TextOut((curColumn - 1) * SCR_X, curRow * SCR_Y, " ", 1);
			curColumn--;
			scr[curRow][curColumn] = ' ';
			color[curRow][curColumn]->bgColor = curColor.bgColor;
			color[curRow][curColumn]->fgColor = curColor.fgColor;
		  }
		  else
		  {
			if ((int) curRow - 1 >= 0)
			{
			  // Go to the end of the previous line and delete that character
			  curRow--;
			  
			  // If the previous line has anything in it...
			  if ((curColumn = getLastCharPos(scr[curRow])) >= 0)
			  {
				// Erase the character before us and reflect that in the buffer
				pDC->TextOut(curColumn * SCR_X, curRow * SCR_Y, " ", 1);
				scr[curRow][curColumn] = ' ';
				color[curRow][curColumn]->bgColor = curColor.bgColor;
				color[curRow][curColumn]->fgColor = curColor.fgColor;
			  }
			  else
				curColumn = 0;
			}
		  }
		}
		break;
	  }
	  
	  case '\t' :
	  {
		// Tab; display 1 space * m_tabSpace
		long i;
		for (i = 0; i <= m_tabSpace - 1; i++)
		{
		  pDC->TextOut((curColumn + i) * SCR_X, curRow * SCR_Y, " ", 1);
		  scr[curRow][curColumn + i] = ' ';
		}
		curColumn += m_tabSpace;
		break;
	  }
	  
	  default :
	  {
		// A printable character
		
		// Be a psychic and look into the future to see how many printable
		// characters we can handle at the same time in the same line :-)
		LPSTR strOutput;
		HGLOBAL hstrOutput;
		int future = i + 1;
		int g;
		
		while (future <= end)
		{
		  if ((str[future] == 10) || (str[future] == 13) || (str[future] == 8) || (str[future] == 9) || ((future - i) + curColumn > m_columns - 1))
			break;
		  future++;
		}
		future--;
		
		// Allocate and assign the strOutput string
		hstrOutput = GlobalAlloc(GHND, sizeof(BYTE) * (future - i + 2));
		strOutput = (LPSTR) GlobalLock(hstrOutput);
		for (g = 0; g <= future - i; g++)
		  strOutput[g] = str[g + i];
		strOutput[future - i + 1] = '\0';
		
		// Write the string
		pDC->TextOut(curColumn * SCR_X, curRow * SCR_Y, strOutput, lstrlen(strOutput));
		
		// Reflect these changes in the buffer
		for (g = curColumn; g <= curColumn + (future - i); g++)
		{
		  scr[curRow][g] = str[(g - curColumn) + i];
		  color[curRow][g]->bgColor = curColor.bgColor;
		  color[curRow][g]->fgColor = curColor.fgColor;
		}
		
		// Advance the row and column positions
		curColumn += (future - i) + 1;
		i = future;
		if (curColumn == m_columns)
		{
		  // It is time to go to the next line
		  curColumn = 0;
		  curRow++;
		  
		  // If our row is now after the end, set the current character
		  // to a newline so that appropriate processing may take place
		  if (curRow > m_rows - 1)
		  {
			//			str[future] = '\n';
			// Scroll the current window up by one
			LPSTR firstRow = scr[0];
			LPCOLORINFO *colorRow = color[0];
			RECT rect, newRect;
			int r;
//			i = future - 1;
			
			// Initialize rectangle variables
			rect.top = 0;
			rect.bottom = m_rows * SCR_Y;
			rect.left = 0;
			rect.right = m_columns * SCR_X;
			
			// Scroll the DC
			pDC->ScrollDC(0, -1 * SCR_Y, &rect, NULL, NULL, &newRect);
			
			// Reflect this change in memory by moving every row up by one
			for (r = 0; r <= m_rows - 2; r++)
			{
			  scr[r] = scr[r + 1];
			  color[r] = color[r + 1];
			}
			scr[m_rows - 1] = firstRow;
			color[m_rows - 1] = colorRow;
			
			// Clear the bottom row on the screen
			memset(scr[m_rows - 1], ' ', m_columns);
			pDC->TextOut(0, (m_rows - 1) * SCR_Y, scr[m_rows - 1], m_columns);
			
			// Clear the bottom row in memory (with NULLs this time)
			memset(scr[m_rows - 1], '\0', m_columns);
			
			// Set every color in the bottom row to the current colors
			for (r = 0; r <= m_columns - 1; r++)
			{
			  color[m_rows - 1][r]->bgColor = curColor.bgColor;
			  color[m_rows - 1][r]->fgColor = curColor.fgColor;
			}
			
			// Set the current row to the last one
			curRow--;

			// Handle inRow
			if (inPosSet)
			  inRow--;
		  }
		}
		
		// Free the memory object
		GlobalUnlock(hstrOutput);
		GlobalFree(hstrOutput);
		break;
	  }
     
    } /* switch */

    // Process the next character in the output buffer
    i++;

  } /* while */

  // Done with processing; free str and "clean up" the DC
//  pDC->SelectPalette(pOldPal, false);
  pDC->SelectObject(pOldFont);
  ReleaseDC(pDC);
		  
  // Set the caret position to the current row/column
  SetCaretState(true, true);
		  
  // Return success
  return true;
}

BOOL CScreenWindowCtrl::WriteLine(LPCTSTR str) 
{
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  bool retVal = internalWrite(str);
  if (retVal)
    retVal = retVal && internalWrite("\n");
  screenMutex->Unlock();
  //delete screenLock;
  return retVal;
}

BOOL CScreenWindowCtrl::ClearInput() 
{
  // Clear the input buffer
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  scrIn[0] = '\0';
  screenMutex->Unlock();
  //delete screenLock;
  return true;
}

BSTR CScreenWindowCtrl::ReadLine() 
{
  // Wait until the user presses [Enter], or had pressed it
  HGLOBAL hGlobal;
  LPSTR lineText;
  CString str;
  int end, i;
  int pos;
  //CSingleLock *inputLock = new CSingleLock(inputMutex, false);
  inputMutex->Lock(INFINITE);
  
  // Get an input
  inRow = curRow;
  inColumn = curColumn;
  inPosSet = true;
  asyncRead = false;
  echoChars = true;
  WaitForEoln();
  echoChars = false;
  inRow = 0;
  inColumn = 0;
  inPosSet = false;
  
  // Find out where the carriage return is
  pos = 0;
  end = lstrlen(scrIn) - 1;
  while ((scrIn[pos] != '\r') && (pos <= end))
	pos++;
  
  // Something different is happening; either we're exiting or a
  // function didn't work; return false
  if (pos > end)
	return false;
  
  // Copy our part to the user's string, minus the carriage return
  hGlobal = GlobalAlloc(GHND, (pos + 2) * sizeof(char));
  lineText = (LPSTR) GlobalLock(hGlobal);
  lstrcpyn(lineText, scrIn, pos + 1);
  str = lineText;
  GlobalUnlock(hGlobal);
  GlobalFree(hGlobal);
  
  // Move the other characters in the input buffer down (including terminating NULL)
  end++;
  pos++;
  for (i = pos; i <= end; i++)
	scrIn[i - pos] = scrIn[i];
  inputMutex->Unlock();
  //delete inputLock;
  return str.AllocSysString();
}

BOOL CScreenWindowCtrl::ReadLineAsync() 
{
  // Asynchronous read!
  if (!asyncRead) {
    // Display any text in the buffer up to the 'r', if any
	int i, end, t;
    //CSingleLock *inputLock = new CSingleLock(inputMutex, false);
	inputMutex->Lock(INFINITE);
	BOOL nextLine = false;
	end = lstrlen(scrIn) - 1;
	if ((strstr(scrIn, "\r") != NULL) || (end >= 0))
	{
	  char scrOut[2];
	  i = 0;
	  while ((scrIn[i] != '\r') && (i <= end))
	  {
		scrOut[0] = scrIn[i];
		scrOut[1] = '\0';
		Write(scrOut);
		i++;
	  }
	}
	
	// Remove all the backspaces that exist
	i = 0;
	while ((i <= end) && (i >= 0))
	{
	  // If we encounter a carriage return, stop removing backspaces
	  if (scrIn[i] == '\r') {
		// Copy our part to the user's string, minus the carriage return
		LPSTR lineText;
		HGLOBAL hGlobal;
		hGlobal = GlobalAlloc(GHND, (i + 2) * sizeof(char));
		lineText = (LPSTR) GlobalLock(hGlobal);
		lstrcpyn(lineText, scrIn, i + 1);
		
		// Move the other characters in the input buffer down (including terminating NULL)
		end++;
		i++;
		for (t = i; t <= end; t++)
		  scrIn[t - i] = scrIn[t];
		
		// Write an Enter and unlock the mutex
		Write("\n");
        inputMutex->Unlock();

		// Fire the event, because we already have the text!
		FireReadLineDone(lineText);
		
		// Free the string and return
		GlobalUnlock(hGlobal);
		GlobalFree(hGlobal);
		return true;
	  }
	  
	  // Backspace encountered; process it!
	  if (scrIn[i] == '\b')
	  {
		if (i > 0)
		{
		  for (t = i; t <= end; t++)
			scrIn[t - 1] = scrIn[t + 1];
		  end -= 2;
		  i--;
		}
		else
		{
		  for (t = i; t <= end; t++)
			scrIn[t] = scrIn[t + 1];
		  end--;
		}
	  }
	  else
		i++;
	}
	
	// Set the variables
	inRow = curRow;
	inColumn = curColumn;
	echoChars = true;
	asyncRead = true;
	inPosSet = true;
    inputMutex->Unlock();
    //delete inputLock;
  }
  
  return true;
}

short CScreenWindowCtrl::ReadByte(BOOL readToEoln) 
{
  // Wait until the user presses [Enter], or had pressed it
  //CSingleLock *inputLock = new CSingleLock(inputMutex, false);
  inputMutex->Lock(INFINITE);
  BYTE byteToRead;
  UINT i;
  UINT len = lstrlen(scrIn);
  
  if (readToEoln)
  {
	// Read the entire line first
	echoChars = true;
	inRow = curRow;
	inColumn = curColumn;
	WaitForEoln();
	echoChars = false;
	inRow = 0;
	inColumn = 0;
	len = lstrlen(scrIn);
  }
  else
  {
	// Secure a byte
	if (len == 0)
	{
	  if (!WaitForChar())
		return NULL;
	  len = lstrlen(scrIn);
	}
  }
  
  // Assign byteToRead to the next byte
  byteToRead = scrIn[0];
  
  // Move the other characters in the input buffer down (including terminating NULL)
  for (i = 1; i <= len; i++)
	scrIn[i - 1] = scrIn[i];
  
  // Return the byte
  inputMutex->Unlock();
  //delete inputLock;
  return byteToRead;
}

void CScreenWindowCtrl::makePalette(CPalette *pal)
{
  HGLOBAL hGlobal;
  LPLOGPALETTE lp;

  // Create the palette with the standard colors (including brown)
  hGlobal = GlobalAlloc(GHND, sizeof(LOGPALETTE) + 17 * sizeof(PALETTEENTRY));
  lp = (LPLOGPALETTE) GlobalLock(hGlobal);
  lp->palVersion = 0x300;
  lp->palNumEntries = 17;
  lp->palPalEntry[0].peRed = 0;
  lp->palPalEntry[0].peGreen = 0;
  lp->palPalEntry[0].peBlue = 0;
  lp->palPalEntry[0].peFlags = NULL;
  lp->palPalEntry[1].peRed = 191;
  lp->palPalEntry[1].peGreen = 0;
  lp->palPalEntry[1].peBlue = 0;
  lp->palPalEntry[1].peFlags = NULL;
  lp->palPalEntry[2].peRed = 0;
  lp->palPalEntry[2].peGreen = 191;
  lp->palPalEntry[2].peBlue = 0;
  lp->palPalEntry[2].peFlags = NULL;
  lp->palPalEntry[3].peRed = 128;
  lp->palPalEntry[3].peGreen = 128;
  lp->palPalEntry[3].peBlue = 0;
  lp->palPalEntry[3].peFlags = NULL;
  lp->palPalEntry[4].peRed = 0;
  lp->palPalEntry[4].peGreen = 0;
  lp->palPalEntry[4].peBlue = 191;
  lp->palPalEntry[4].peFlags = NULL;
  lp->palPalEntry[5].peRed = 191;
  lp->palPalEntry[5].peGreen = 0;
  lp->palPalEntry[5].peBlue = 191;
  lp->palPalEntry[5].peFlags = NULL;
  lp->palPalEntry[6].peRed = 0;
  lp->palPalEntry[6].peGreen = 191;
  lp->palPalEntry[6].peBlue = 191;
  lp->palPalEntry[6].peFlags = NULL;
  lp->palPalEntry[7].peRed = 192;
  lp->palPalEntry[7].peGreen = 192;
  lp->palPalEntry[7].peBlue = 192;
  lp->palPalEntry[7].peFlags = NULL;
  lp->palPalEntry[8].peRed = 128;
  lp->palPalEntry[8].peGreen = 128;
  lp->palPalEntry[8].peBlue = 128;
  lp->palPalEntry[8].peFlags = NULL;
  lp->palPalEntry[9].peRed = 255;
  lp->palPalEntry[9].peGreen = 0;
  lp->palPalEntry[9].peBlue = 0;
  lp->palPalEntry[9].peFlags = NULL;
  lp->palPalEntry[10].peRed = 0;
  lp->palPalEntry[10].peGreen = 255;
  lp->palPalEntry[10].peBlue = 0;
  lp->palPalEntry[10].peFlags = NULL;
  lp->palPalEntry[11].peRed = 255;
  lp->palPalEntry[11].peGreen = 255;
  lp->palPalEntry[11].peBlue = 0;
  lp->palPalEntry[11].peFlags = NULL;
  lp->palPalEntry[12].peRed = 0;
  lp->palPalEntry[12].peGreen = 0;
  lp->palPalEntry[12].peBlue = 255;
  lp->palPalEntry[12].peFlags = NULL;
  lp->palPalEntry[13].peRed = 255;
  lp->palPalEntry[13].peGreen = 0;
  lp->palPalEntry[13].peBlue = 255;
  lp->palPalEntry[13].peFlags = NULL;
  lp->palPalEntry[14].peRed = 0;
  lp->palPalEntry[14].peGreen = 255;
  lp->palPalEntry[14].peBlue = 255;
  lp->palPalEntry[14].peFlags = NULL;
  lp->palPalEntry[15].peRed = 255;
  lp->palPalEntry[15].peGreen = 255;
  lp->palPalEntry[15].peBlue = 255;
  lp->palPalEntry[15].peFlags = NULL;
  lp->palPalEntry[16].peRed = 170;
  lp->palPalEntry[16].peGreen = 85;
  lp->palPalEntry[16].peBlue = 0;
  lp->palPalEntry[16].peFlags = NULL;
  pal->CreatePalette(lp);
  GlobalUnlock(hGlobal);
  GlobalFree(hGlobal);
}


void CScreenWindowCtrl::SetCaretState(BOOL state, BOOL on)
{
  // Only modify the caret if the window is on
  if (windowOn) {
	// Change the status of the caret
	if (on != caretActive)
	{
	  if (on)
	  {
		// Enable the caret
		CARETID = SetTimer(CARETID, GetCaretBlinkTime(), NULL);
		caretActive = true;
		state = true;
	  }
	  else
	  {
		// Disable the caret
		KillTimer(CARETID);
		caretActive = false;
		state = false;
	  }
	}
	
	if ((caretStatus != state) && !caretHide)
	{
	  // Invert the area of the caret
	  CDC *pDC = GetDC(NULL, OLEDC_PAINTBKGND);
	  RECT rect;
	  rect.left = curColumn * SCR_X;
	  rect.top = ((curRow + 1) * SCR_Y) - SCR_Y / 8;
	  rect.bottom = ((curRow + 1) * SCR_Y);
	  rect.right = (curColumn + 1) * SCR_X;
	  
	  pDC->InvertRect(&rect);
	  caretStatus = state;
	  ReleaseDC(pDC);
	}
  }
}

void CScreenWindowCtrl::OnTimer(UINT nIDEvent) 
{
  if (nIDEvent == CARETID) {
    // Paint the caret, if it's active
  //CSingleLock *screenLock = new CSingleLock(screenMutex, false);
	screenMutex->Lock(INFINITE);
    if (caretActive)
  	  SetCaretState(!caretStatus, true);
	return;
    screenMutex->Unlock();
    //delete screenLock;
  }
  
  COleControl::OnTimer(nIDEvent);
}

void CScreenWindowCtrl::ChangeAllocation(long rows, long columns)
{
  // See if we are already at this allocation..  If so, then do nothing :-)
  if ((prevRows == rows) && (prevColumns == columns))
	return;

  // Check the parameters
  long i, t;
  if ((rows < 1) || (rows > 200))
  {
	 // Assign the default value to the rows
	 rows = 25;
	 m_rows = 25;
  }
  if ((columns < 1) || (columns > 200))
  {
	 // Assign the default value to the columns
	 columns = 80;
	 m_columns = 80;
  }

  // Remove the previous allocation, if any
  if (scr) {
	FreeAllocation();
  }
  
  // Update the properties
  prevRows = rows;
  prevColumns = columns;

  // Allocate screen buffer to user's size, setting each character to a space in the process
  HGLOBAL hGlobal;
  hGlobal = GlobalAlloc(GHND, sizeof(LPSTR) * rows); // allocate string pointers
  scr = (LPSTR *) GlobalLock(hGlobal);
  hGlobal = GlobalAlloc(GHND, sizeof(LPCOLORINFO **) * rows); // allocate COLORINFO pointers
  color = (LPCOLORINFO **) GlobalLock(hGlobal);
  for (i = 0; i <= rows - 1; i++)
  {
	// Each row's string
	hGlobal = GlobalAlloc(GHND, sizeof(BYTE) * (columns + 1)); // assign pointers
	scr[i] = (LPSTR) GlobalLock(hGlobal);
	memset(scr[i], ' ', sizeof(BYTE) * columns);
	scr[i][columns] = '\0';
	
	// Each row's color values
	hGlobal = GlobalAlloc(GHND, sizeof(LPCOLORINFO *) * columns); // allocate COLORINFO pointers
	color[i] = (LPCOLORINFO *) GlobalLock(hGlobal);
	
	for (t = 0; t <= columns - 1; t++)
	{
	  hGlobal = GlobalAlloc(GHND, sizeof(COLORINFO)); // allocate COLORINFO pointers
	  color[i][t] = (LPCOLORINFO) GlobalLock(hGlobal);
	  color[i][t]->bgColor = curColor.bgColor;
	  color[i][t]->fgColor = curColor.fgColor;
	}
  }

  // Set the column and row to zero
  curRow = 0;
  curColumn = 0;
}

void CScreenWindowCtrl::FreeAllocation()
{
  HGLOBAL hGlobal;
  long i, t;
  
  for (i = 0; i < prevRows; i++)
  {
	// Each row's color values
	for (t = 0; t < prevColumns ; t++)
	{
	  hGlobal = GlobalHandle(color[i][t]);
	  GlobalUnlock(hGlobal);
	  GlobalFree(hGlobal);
	}
	hGlobal = GlobalHandle(color[i]);
	GlobalUnlock(hGlobal);
	GlobalFree(hGlobal);
	
	// Each row's string
	hGlobal = GlobalHandle(scr[i]);
	GlobalUnlock(hGlobal);
	GlobalFree(hGlobal);
  }
  
  // The base variables
  hGlobal = GlobalHandle(scr);
  GlobalUnlock(hGlobal);
  GlobalFree(hGlobal);
  hGlobal = GlobalHandle(color);
  GlobalUnlock(hGlobal);
  GlobalFree(hGlobal);
  scr = NULL;
  color = NULL;
}

void CScreenWindowCtrl::WaitForEoln()
{
  // Wait until there '\r' exists in the input buffer
  
  // Display any text in the buffer up to the 'r', if any
  int i, end, t;
  end = lstrlen(scrIn) - 1;
  if ((strstr(scrIn, "\r") != NULL) || (end >= 0))
  {
	char scrOut[2];
	i = 0;
	while ((scrIn[i] != '\r') && (i <= end))
	{
	  scrOut[0] = scrIn[i];
	  scrOut[1] = '\0';
	  Write(scrOut);
	  i++;
	}
  }
  
  // Remove all the backspaces that exist
  i = 0;
  while ((i <= end) && (i >= 0))
  {
	// If we encounter a carriage return, stop removing backspaces
	if (scrIn[i] == '\r')
	  break;
	
	// Backspace encountered; process it!
	if (scrIn[i] == '\b')
	{
	  if (i > 0)
	  {
		for (t = i; t <= end; t++)
		  scrIn[t - 1] = scrIn[t + 1];
		end -= 2;
		i--;
	  }
	  else
	  {
		for (t = i; t <= end; t++)
		  scrIn[t] = scrIn[t + 1];
		end--;
	  }
	}
	else
	  i++;
  }
  
  // Loop until we find a carriage return
  while (strstr(scrIn, "\r") == NULL)
  {
	// Wait for the next character
	if (!WaitForChar())
	  return;
	
	// Check next character; if it's a backspace, process it
	i = (int) lstrlen(scrIn) - 1;
	if (i >= 0)
	{
	  if (scrIn[i] == '\b')
	  {
		if (i > 0)
		  i--;
		scrIn[i] = '\0';
	  }
	}
//	nextLine = true;
  }
  
  if (echoChars)
  {
	// Advance to the next line if the [Enter] was pressed
	Write("\n");
  }
}

BOOL CScreenWindowCtrl::WaitForChar()
{
  // Message Loop that quits with WM_QUIT or when a character was just typed
  MSG msg;
  while (true)
  {
	 // Wait for another message and get that message
	 WaitMessage();
	 PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);

	 // Standard message handling
	 TranslateMessage(&msg);
	 DispatchMessage(&msg);

	 // User is quitting; exit this procedure!!
	 if (msg.message == WM_QUIT)
		return false;

	 // A character was just pressed!
	 if (msg.message == WM_CHAR)
		return true;
  }
}

long CScreenWindowCtrl::getLastCharPos(LPCTSTR line)
{
  long pos = m_columns - 1;
  if (echoChars && (scrIn[strlen(scrIn) - 1] != '\n'))
	return pos;
  while (pos >= 0)
  {
    if (line[pos] != ' ')
   	  break;
	pos--;
  }
  return pos;
}

int CScreenWindowCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
  if (COleControl::OnCreate(lpCreateStruct) == -1)
	return -1;
  
  // Load the font into hFont
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  //CSingleLock *inputLock = new CSingleLock(inputMutex, false);
  inputMutex->Lock(INFINITE);
  pFont = new CFont();
  pFont->CreateFont(12, 0, 0, 0, 0, 0, 0, 0, 255, 0, 0, 0, 0, "Terminal");
  
  // Set the default colors to the properties
  curColor.bgColor = TranslateColor(m_textBackgroundColor);
  curColor.fgColor = TranslateColor(m_textColor);
  
  // Create an allocation for the screen
  m_columns = lpCreateStruct->cx / SCR_X;
  m_rows = lpCreateStruct->cy / SCR_Y;
//  SetWindowPos(NULL, 0, 0, m_columns * SCR_X, m_rows * SCR_Y, SWP_NOMOVE | SWP_NOREDRAW | SWP_NOSENDCHANGING | SWP_NOZORDER);
  scr = NULL;
  ChangeAllocation(m_rows, m_columns);
  SetControlSize(m_columns * SCR_X, m_rows * SCR_Y);
  
  // Assign the default input buffer length and allocate that space
  m_inputLength = m_rows * m_columns;
  hscrIn = GlobalAlloc(GHND, m_inputLength + 2);
  scrIn = (LPSTR) GlobalLock(hscrIn);
  scrIn[0] = '\0';
  
  // Set the echo flag to false
  echoChars = false;
  
  // Set the tab space to the default
  m_tabSpace = 5;
  
  // Set the input row/columns
  inRow = 0;
  inColumn = 0;
  inPosSet = false;
  
  // The window is on :-)!
  windowOn = true;
  
  // Create a hidden caret
  caretHide = true;
  caretActive = false;
  caretStatus = false;

  // We're done, so fire the LoadFinished event
  screenMutex->Unlock();
  //delete screenLock;
  inputMutex->Unlock();
  //delete inputLock;
  FireLoadFinished();
  return 0;
}

void CScreenWindowCtrl::OnDestroy() 
{
  // Clear the caret
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  SetCaretState(false, false);

  // Unset the windowOn
  windowOn = false;

  // Free the input buffer
  GlobalUnlock(hscrIn);
  GlobalFree(hscrIn);

  // Delete the font
  delete pFont;

  // Free the screen buffers
  FreeAllocation();
  screenMutex->Unlock();
  //delete screenLock;
	
  COleControl::OnDestroy();
}

BOOL CScreenWindowCtrl::OnEraseBkgnd(CDC* pDC) 
{
  // Repaint everything
//  InvalidateControl(NULL);
  return true;
}

BOOL CScreenWindowCtrl::OnGetNaturalExtent(DWORD dwAspect, LONG lindex, DVTARGETDEVICE* ptd, HDC hDC, DVEXTENTINFO* pExtentInfo, LPSIZEL pNewSize)
{
  // If the window is not on, then forget it
  if (!windowOn)
    return COleControl::OnGetNaturalExtent(dwAspect, lindex, ptd, hDC, pExtentInfo, pNewSize);

  // See what the OLE client wants
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  if (pExtentInfo->dwExtentMode == DVEXTENT_CONTENT) {
	// Return the size required for the current number of rows and columns
	pNewSize->cx = SCR_X * m_columns;
	pNewSize->cy = SCR_Y * m_rows;
	CDC *pDC = GetDC();
    pDC->DPtoHIMETRIC(pNewSize);
	ReleaseDC(pDC);
    screenMutex->Unlock();
    //delete screenLock;
    return true;
  }	
  if (pExtentInfo->dwExtentMode == DVEXTENT_INTEGRAL) {
	// Adjust the size according to the device context
	pNewSize->cx = pExtentInfo->sizelProposed.cx;
	pNewSize->cy = pExtentInfo->sizelProposed.cy;
	CDC *pDC = GetDC();
    pDC->HIMETRICtoDP(pNewSize);
	pNewSize->cx = (pNewSize->cx / SCR_X) * SCR_X;
	pNewSize->cy = (pNewSize->cy / SCR_Y) * SCR_Y;
	if (pNewSize->cx == 0)
	  pNewSize->cx = SCR_X;
	if (pNewSize->cy == 0)
	  pNewSize->cy = SCR_Y;
	
	// Clean up the DC
	pDC->DPtoHIMETRIC(pNewSize);
	ReleaseDC(pDC);

	// Return true

    screenMutex->Unlock();
    //delete screenLock;
	return true;
  }
  screenMutex->Unlock();
  //delete screenLock;
  return COleControl::OnGetNaturalExtent(dwAspect, lindex, ptd, hDC, pExtentInfo, pNewSize);
}

/*BOOL CScreenWindowCtrl::OnSetObjectRects(LPCRECT lpRectPos, LPCRECT lpRectClip) 
{
  COleControl::OnSetObjectRects(lpRectPos, lpRectClip);

  // Update the allocation (this wipes out the display)
//CSingleLock *screenLock = new CSingleLock(screenMutex, false);
  screenMutex->Lock(INFINITE);
  m_rows = lpRectPos->bottom / SCR_Y;
  m_columns = lpRectPos->right / SCR_X;
  ChangeAllocation(m_rows, m_columns);

  // Set the column and row to zero
  curRow = 0;
  curColumn = 0;

  // Repaint the control
  screenMutex->Unlock();
  //delete screenLock;
  InvalidateControl(NULL);

  SetModifiedFlag();
  return true;
}*/

BOOL CScreenWindowCtrl::OnSetExtent(LPSIZEL lpSizeL) 
{
  COleControl::OnSetExtent(lpSizeL);

  // Update the allocation (this wipes out the display)
  if (windowOn) {
  //CSingleLock *screenLock = new CSingleLock(screenMutex, false);
	SIZEL pSizeL;
	pSizeL.cx = lpSizeL->cx;
	pSizeL.cy = lpSizeL->cy;
    CDC *pDC = GetDC(NULL, OLEDC_PAINTBKGND);
    pDC->HIMETRICtoDP(&pSizeL);
    ReleaseDC(pDC);
	if ((pSizeL.cx / SCR_X == 0) && (pSizeL.cy / SCR_Y == 0)) {
	  SetControlSize(SCR_X, SCR_Y);
	  return true;
	}
	if ((pSizeL.cx % SCR_X == 0) && (pSizeL.cy % SCR_Y == 0)) {
	  // Correct size in place -- resize
      screenMutex->Lock(INFINITE);
      m_columns = pSizeL.cx / SCR_X;
      m_rows = pSizeL.cy / SCR_Y;
      ChangeAllocation(m_rows, m_columns);

      // Repaint the control
      screenMutex->Unlock();
      InvalidateControl(NULL);
	} else
	  // Resize to the correct size
	  SetControlSize((pSizeL.cx / SCR_X) * SCR_X, (pSizeL.cy / SCR_Y) * SCR_Y);
  }
  SetModifiedFlag();
  return true;
}


void CScreenWindowCtrl::OnSize(UINT nType, int cx, int cy) 
{
	COleControl::OnSize(nType, cx, cy);
	
  // Update the allocation (this wipes out the display)
  if (windowOn && (nType != SIZE_MINIMIZED) && (nType != SIZE_MAXHIDE) && (nType != SIZE_MAXSHOW)) {
  //CSingleLock *screenLock = new CSingleLock(screenMutex, false);
	if ((cx / SCR_X == 0) && (cy / SCR_Y == 0)) {
	  SetControlSize(SCR_X, SCR_Y);
	  return;
	}
	if ((cx % SCR_X == 0) && (cy % SCR_Y == 0)) {
	  // Correct size in place -- resize
      screenMutex->Lock(INFINITE);
      m_columns = cx / SCR_X;
      m_rows = cy / SCR_Y;
      ChangeAllocation(m_rows, m_columns);

      // Repaint the control
      screenMutex->Unlock();
      InvalidateControl(NULL);
	} else
	  // Resize to the correct size
	  SetControlSize((cx / SCR_X) * SCR_X, (cy / SCR_Y) * SCR_Y);
  }
  SetModifiedFlag();
}

void CScreenWindowCtrl::OnFontWidthChanged() 
{
  // Resize to the correct size
  SetControlSize(m_columns * SCR_X, m_rows * SCR_Y);
  SetModifiedFlag();
}

void CScreenWindowCtrl::OnFontHeightChanged() 
{
  // Resize to the correct size
  SetControlSize(m_columns * SCR_X, m_rows * SCR_Y);
  SetModifiedFlag();
}

